#!/bin/sh

# set time limit based on what caller specified. Exec script that will send
# SIGTERM to tcpdump to force this script to run the END block. Background
# this so it doesn't interrupt nawk processing below.

# Invoke tcpdump with options and pipe through nawk to gather data. The
# running of tcpdump is limited to the time specified by the caller. I 
# am only interested in the ip protocol packets. I will get the source
# and destination addresses with the ''ip' specifier at $3 and $5 respectively.
# Do not track outgoing packets from this host as part of tracing data. This is
# achieved by the 'src host not loghost' qualifier.

#
# I need to dump on every interface I find on system. so, call ifconfig -a
# first, to get interface name. Call tcpdump on these.

INTERFACES=`ifconfig -a | nawk ' {
	# Get the interface name
	x=split($1, ifname, ":")
	if (x != 1) {
		newif[i]=ifname[1]
		if (newif[i] != "lo0")
			printf("%s ", newif[i])
		i = i + 1 
	}
} '`
for i in $INTERFACES
do 
# for each interface check number of packets , if over threshold, report
./dumper.sh $i $2 > /tmp/o_$i &
done
# kill this process in $1 amount of time
trace_kill $1 
cat /tmp/o_*
rm /tmp/o_*
