#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <errno.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <inttypes.h>

void
main() {

	int			rcv;
	int			length;
	int			n;
	int			rval;
	int			msgsock;
	int			cnt;
	struct sockaddr_in	from_addr;
	char			buf[1024];

	/* Set up our listening socket */
	if ((rcv = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
	    perror(strerror(errno));
	    exit(1);
	}

	bzero (&from_addr, sizeof(from_addr));
	from_addr.sin_family = AF_INET;
	from_addr.sin_addr.s_addr = INADDR_ANY;
	from_addr.sin_port = htons(7654);

	if (bind(rcv, (struct sockaddr *) &from_addr, sizeof (from_addr)) < 0) {
	    perror("binding stream socket");
	    exit(1);
	}

	length = sizeof (from_addr);
	if (getsockname(rcv, (struct sockaddr *) &from_addr, &length)
	    < 0) {
	    perror("getting socket name");
	    exit(1);
	}

	printf("Socket port #%d\n", ntohs(from_addr.sin_port));

	/* Start accepting connections. */
	listen(rcv, 5);

	while (1) {
	    msgsock = accept(rcv, (struct sockaddr *) 0, (int *) 0);
	    if (msgsock == -1) {
		perror("accept");
	    } else {

		cnt = 0;
		do {
		    memset(buf, 0, sizeof (buf));
		    if ((rval = read(msgsock, buf, 1024)) == -1) {
			perror("reading stream message");
			exit(1);
		    }

		    if (rval == 0)
			printf("Ending connection\n");
		    /* else printf("-->%s\n", buf); */

		    if (cnt++ % 1000 == 0)
			printf("rcvd %d\n", cnt);
		} while (rval > 0);

		close(msgsock);
	    }
	}

	/*NOTREACHED*/
}
