#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <strings.h>
#include <errno.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <inttypes.h>
#include <stropts.h>
#include <sys/select.h>

static char msg[] = "This is a test of the emergency broadcast system, "
	"this is only a test.  If this had been a real emergency...";

void
main(int argc, char **argv)
{
	int			snd;
	int			i;
	int			errnum;
	int			cnt;
	struct sockaddr_in	snd_addr;
	struct	hostent		*hp;

	if (argc < 2) {
	    fprintf(stderr, "missing host arg\n");
	    exit(1);
	}

	if ((snd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
	    perror("Could not initialize socket");
	    exit(1);
	}

	bzero (&snd_addr, sizeof (snd_addr));
	snd_addr.sin_family = AF_INET;
	snd_addr.sin_port = htons(7654);
	/* inet_pton(AF_INET, argv[1], &snd_addr.sin_addr); */

	hp = getipnodebyname(argv[1], AF_INET, AI_DEFAULT, &errnum);
	if (hp == (struct hostent *) 0) {
	    fprintf(stderr, "%s: unknown host\n", argv[1]);
	    exit(0);
	}

	for (i = 0; hp->h_addr_list[i] != NULL; i++) {
	    bcopy(hp->h_addr_list[i], &snd_addr.sin_addr, hp->h_length);

	    if (connect(snd, (struct sockaddr *) &snd_addr, sizeof(snd_addr))
		== 0)
		break;

	    if (hp->h_addr_list[i + 1] == NULL) {
		perror("connecting stream socket");
		freehostent(hp);
		exit(1);
	    }
	}
	freehostent(hp);

	cnt = 0;
	while (1) {
	    if (write(snd, msg, sizeof (msg)) < 0) {
		perror("Could not send message");
		exit(1);
	    }
	    if (cnt++ % 1000 == 0)
		printf("sent %d\n", cnt);
	}

	close(snd);
	exit(0);
}
